/*
 * LcaDrfIW.h - Internal version of include file LcaDrfW.h
 * Copyright (c) 1996 - 2003 by Echelon Corporation
 * All Rights Reserved
 * Implementation by RLE
 */

#ifndef _LCADRFIW
#define _LCADRFIW

#include "lcadrfi.h"

#ifdef __cplusplus
extern "C" {
#endif

/* The hash table structures, which hang off the file info structure for lang resource files */

struct sHashTbl {
    PHashTblEntry pEntry[65536];
};

struct sHashTblEntry {
    PHashTblEntry pNextEntry;
    TULong	  address;
};



/* * * * Prototypes from drfbasew.c * * * */

	/* FILE DIRECTORY MANAGEMENT AND SUPPORT FUNCTIONS */

extern	TLdrfErrCodes
LdrfInsertSorted (PLdrfFileInfo pInfo, PULong pDir, TULong numEntries,
		  LPCSTR pNewEntry, PULong pEntry, PLdrfCompareFn fn);

extern	TLdrfErrCodes
LdrfDeleteSorted (PULong pDir, TULong numEntries, TULong dirEntryValue);


	/* TEST CODE SUPPORT */

LDRF_FN LdrfTestFixture (long testSelect);



/* * * * Prototypes from drfunlok.c * * * */
extern	TBool
LdrfUnlOK ();


/* * * * Prototypes from drfgenw.c * * * */

extern	TLdrfErrCodes
LdrfEditFileCommon (LPCSTR path, TLdrfFileType fileType,
		    TUByte majFmtForCreate, PLdrfFileInfo * ppInfo);

extern	TLdrfErrCodes
LdrfConvertFileMain (LPCSTR pathIn, LPCSTR pathOut,
		     TUByte toVersion, TBool checkCRC,
		     TBool purgeDeletedRecords);

extern	TLdrfErrCodes
LdrfConvertStringFile (PLdrfFileInfo pInfoIn, PLdrfFileInfo pInfoOut,
		       TUByte fromVersion, TUByte toVersion,
		       TBool purgeDeletedRecords);

extern	TLdrfErrCodes
LdrfConvertTypeFile (PLdrfFileInfo pInfoIn, PLdrfFileInfo pInfoOut,
		     TUByte fromVersion, TUByte toVersion,
		     TBool purgeDeletedRecords);

extern	TLdrfErrCodes
LdrfConvertFPTFile (PLdrfFileInfo pInfoIn, PLdrfFileInfo pInfoOut,
		    TUByte fromVersion, TUByte toVersion,
		    TBool purgeDeletedRecords);



/* * * * Prototypes from drflangw.c * * * */

	/* LANGUAGE RESOURCE FILE HEADER MANAGEMENT AND SUPPORT FUNCTIONS */

extern	TLdrfErrCodes
LdrfInitLangFileHeader (PLdrfFileInfo pInfo, TUByte majFmt);

extern	TLdrfErrCodes
LdrfWriteLangFileHeader (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfExpandLangFileHeader (PLdrfFileInfo pInfo, TULong headerSizeIncrement);

extern	TLdrfErrCodes
LdrfRelocateLangFileData (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfIncreaseCapacityStrings (PLdrfFileInfo pInfo);

	/* HASH TABLE FUNCTIONS */

extern	TLdrfErrCodes
LdrfCreateLangHashTable (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfFindViaHashTable (PLdrfFileInfo pInfo, LPCSTR string, PULong pIndex);

extern	TLdrfErrCodes
LdrfInsertInHashTable (PLdrfFileInfo pInfo, TUShort hashCode, TULong address);



/* * * * Prototypes from drftypew.c * * * */

	/* TYPE FILE HEADER MANAGEMENT AND SUPPORT FUNCTIONS */

extern	TLdrfErrCodes
LdrfInitTypeFileHeader (PLdrfFileInfo pInfo, TUByte majFmt);

extern	TLdrfErrCodes
LdrfWriteTypeFileHeader (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfExpandTypeFileHeader (PLdrfFileInfo pInfo, TULong headerSizeIncrement);

extern	TLdrfErrCodes
LdrfRelocateTypeFileData (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfIncreaseCapacityNVT (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfIncreaseCapacityCPT (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfIncreaseCapacityEnumSet (PLdrfFileInfo pInfo);

	/* ENUM SET MANAGEMENT AND SUPPORT FUNCTIONS */

extern	TLdrfErrCodes
LdrfOutputEnumSet (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfWriteEnumSet (PLdrfFileInfo pInfo);

	/* NVT AND CPT MANAGEMENT AND SUPPORT FUNCTIONS */

extern	TLdrfErrCodes
LdrfNVTWrite (PLdrfFileInfo pInfo, TULong startAddress,
	      TUShort index, PLdrfTypeTree pTypeTree, LPSTR * pNameCopy, TUShort flags);

extern	TLdrfErrCodes
LdrfCPTWrite (PLdrfFileInfo pInfo, TULong startAddress, TUShort index,
	      PLdrfTypeTree pTypeTree, TBool inheritable, LPSTR * pNameCopy,
	      PUByteArray pMin, PUByteArray pMax, PUByteArray pInit, PUByteArray pInvalid, 
	      TUShort byteArrayLen, TUShort flags);



/* * * * Prototypes from drffptw.c * * * */

	/* FPT FILE HEADER MANAGEMENT AND SUPPORT FUNCTIONS */

extern	TLdrfErrCodes
LdrfInitFPTFileHeader (PLdrfFileInfo pInfo, TUByte majFmt);

extern	TLdrfErrCodes
LdrfWriteFPTFileHeader (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfExpandFPTFileHeader (PLdrfFileInfo pInfo, TULong headerSizeIncrement);

extern	TLdrfErrCodes
LdrfRelocateFPTFileData (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfIncreaseCapacityFPT (PLdrfFileInfo pInfo);

extern	TLdrfErrCodes
LdrfModifyFPTInherit	(PLdrfFileInfo pInfo, TUShort index,
			 TBoolByte inheritMark);

extern	TLdrfErrCodes
LdrfVerifyFPTNVMemberNumber (PLdrfFileInfo pInfo, TUShort thisNVIndex,
			     TUShort numFPTNVMembers, TUShort NVMemberNumber);

extern	TLdrfErrCodes
LdrfVerifyFPTCPMemberNumber (PLdrfFileInfo pInfo, TUShort numFPTNVMembers,
			     TUShort thisCPIndex,
			     TUShort numFPTCPMembers, TUShort CPMemberNumber);



#ifdef __cplusplus
} /* end of: extern "C" */
#endif


#endif
